(*
Copyright 2009-2013 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Min_Set_Order_Impl
imports
  List_Order_Impl
  Min_Set_Order
begin

definition min_set_ext :: "'a list_ext_impl" where
  "min_set_ext s_ns = (\<lambda> as bs. 
  (bs \<noteq> [] \<and> (\<forall> a \<in> set as. \<exists> b \<in> set bs. fst (s_ns a b)),  
  (\<forall> a \<in> set as. \<exists> b \<in> set bs. snd (s_ns a b))))"

lemma min_set_ext_list_ext:
  "\<exists> s ns. list_order_extension_impl s ns min_set_ext"
proof(intro exI)
  interpret list_order_extension min_set_s_order min_set_ns_order by (rule min_set_order)
  show "list_order_extension_impl min_set_s_order min_set_ns_order min_set_ext"
    by (unfold_locales, (force simp: min_set_ext_def min_set_s_order_def min_set_ns_order_def)+)
qed

end

